<?

require_once "Exemple2_classes.inc";
require_once "Exemple3_descriptions.inc";


function	echoEntete($id_def = NULL)
{
	global $table, $d2pManager;
?>
<FORM METHOD='post'>
 <INPUT TYPE='hidden' NAME='action' VALUE='edit' />
 <TABLE>
  <TR>
   <TD>
<?php
	if	(is_null($id_def))
		$def = NULL;
	else
		$def = &$d2pManager->objectFromBase($table, $id_def);
	echo $d2pManager->getHTMLPopuplistFromBase(
		$table, "SELECT * FROM \"$table\"", $def, "identifier"
	);
?>
   </TD>
   <TD>
    <INPUT TYPE='submit' VALUE='edit' />
   </TD>
   <TD>
    <A HREF='?action=new'>Create new record</A> -
    <A HREF='?action=list'>Display list</A>
   </TD>
  </TR>
 </TABLE>
</FORM>
<HR/>
<?php
}


$pg = pg_connect("dbname=tseeker user=tseeker");
if	(!$pg)
{
	echo "Unable to connect\n";
	exit(1);
}
$d2pManager->setDatabaseConnection($pg);

session_start();

if	($action == "zap")
{
	session_destroy();
	unset($action);
}

if	($action == "kill")
{
	session_destroy();
	echo "<A HREF='?action='>You may create a new session</A>";
	exit(0);
}


$tables = array(
	"ta", "tb", "tc", "td", "te", "tf", "th", "tb_ta_link", "tc_td_link"
);


if	(!session_is_registered("table"))
{
	$table = $tables[0];
	session_register("table");
	$stlist = join(",", $tables);
	session_register("stlist");
}
elseif	(strcmp($stlist, join(",", $tables)))
{
	$table = $tables[0];
	$stlist = join(",", $tables);
}
if	(isset($ntable) && !(array_search($ntable, $tables, true) === FALSE))
	$table = $ntable;

$tObj = &$d2pManager->getTable($table);


echo "Tables : ";
foreach ($tables as $t)
{
	echo "<A HREF='?ntable=$t'>$t</A> ";
}
echo "<BR/>";
echo "TABLE BEING EDITED : $table<BR/>";
echo "<A HREF='?action=zap'>Reset session</A> - <A HREF='?action=kill'>Kill session</A><BR/><BR/>";


//$pg = @pg_connect("host=dbhost dbname=dbname user=dbuser password=dbpass");
$pg = @pg_connect("dbname=tseeker user=tseeker");
if	(!$pg)
{
	echo "Unable to connect\n";
	exit(1);
}
$d2pManager->setDatabaseConnection($pg);


if	(!isset($action) || $action == "" || !strcmp($action, "list"))
{
	echoEntete();
	echo "<TABLE BORDER='1'>\n";
	$fl = array();
	foreach	($tObj->fields as $fn => $f)
	{
		array_push($fl, $fn);
	}
	echo $d2pManager->getHTMLTabFromBase($table, "SELECT * FROM \"$table\"", $fl);
	echo "</TABLE>\n";
}
elseif	(!strcmp($action, "new"))
{
	echoEntete();
	$obj = &$d2pManager->newObject($table);
	echo "<FORM METHOD='post'>\n";
	echo "<INPUT TYPE='hidden' NAME='action' VALUE='create' />\n";
	echo "<TABLE>\n";
	echo $obj->getHTMLForm();
	echo "</TABLE>\n";
	echo "<INPUT TYPE='submit' VALUE='create record' />\n";
	echo "</FORM>\n";
}
elseif	(!strcmp($action, "edit") && isset($identifier))
{
	$av = explode(",", $identifier);
	if	(count($av) == 1)
		$tmp = $av[0];
	else
	{
		$tmp = array();
		for	($i=0;$i<count($av);$i+=2)
			$tmp[$av[$i]] = $av[$i+1];
	}
	$obj = &$d2pManager->objectFromBase($table, $tmp);
	if	(is_object($obj))
	{
		echoEntete($obj->getIdentifier());
		echo "<FORM METHOD='post'>\n";
		echo "<INPUT TYPE='hidden' NAME='action' VALUE='modify' />\n";
		echo "<TABLE>\n";
		echo $obj->getHTMLForm();
		echo "</TABLE>\n";
		echo "<INPUT TYPE='submit' VALUE='modify' />\n";
		echo "<INPUT TYPE='submit' NAME='DELETE' VALUE='delete record' />\n";
		echo "</FORM>\n";
	}
	else
	{
		echoEntete();
		echo "<FONT COLOR='red'>Unable to find the object with the $identifier identifier</FONT>";
		exit(0);
	}
}
elseif	(!strcmp($action, "create"))
{
	$obj = &$d2pManager->newObject($table);
	$obj->getFormInput();
	if	($d2pManager->commit())
	{
		echoEntete();
		echo "<TABLE>\n";
		echo "<TR><TD ALIGN='CENTER'>NEW RECORD CREATED</TD></TR>\n";
		echo "<TR><TD ALIGN='RIGHT'><A HREF='?action=list'>Back to the list</A></TD></TR>\n";
		echo "</TABLE>\n";
	}
	else
	{
		echoEntete();
		echo "<FONT COLOR='red'>An error has occured ; the record was not created</FONT><BR/>\n";
		echo "<FORM METHOD='post'>\n";
		echo "<INPUT TYPE='hidden' NAME='action' VALUE='create' />\n";
		echo "<TABLE>\n";
		echo $obj->getHTMLForm();
		echo "</TABLE>\n";
		echo "<INPUT TYPE='submit' VALUE='create new record' />\n";
		echo "</FORM>\n";
	}
}
elseif	(!strcmp($action, "modify"))
{
	$obj = &$d2pManager->objectFromForm($table);

	if	(isset($DELETE))
	{
		$obj2 = $obj;
		$obj->destroy();
	}
	if	($d2pManager->commit())
	{
		if	(!$DELETE)
		{
			echoEntete($obj->getIdentifier());
			echo "<FORM METHOD='post'>\n";
			echo "<INPUT TYPE='hidden' NAME='action' VALUE='modify' />\n";
			echo "<TABLE>\n";
			echo "<TR><TD ALIGN='CENTER' COLSPAN='2'>THE RECORD HAS BEEN UPDATED</TD></TR>\n";
			echo $obj->getHTMLForm();
			echo "</TABLE>\n";
			echo "<INPUT TYPE='submit' VALUE='modify' />\n";
			echo "<INPUT TYPE='submit' NAME='DELETE' VALUE='delete record' />\n";
			echo "</FORM>\n";
		}
		else
		{
			echoEntete();
			echo "Record destroyed<BR/>";
			echo "<A HREF='?action=list'>Back to the list</A>\n";
		}
	}
	else
	{
		echoEntete(isset($DELETE) ? $obj2->getIdentifier() : $obj->getIdentifier());
		echo "<FONT COLOR='red'>An error has occured ; the record was not updated</FONT><BR/>\n";
		echo "<FORM METHOD='post'>\n";
		echo "<INPUT TYPE='hidden' NAME='action' VALUE='modify' />\n";
		echo "<TABLE>\n";
		if	(isset($DELETE))
			echo $obj2->getHTMLForm();
		else
			echo $obj->getHTMLForm();
		echo "</TABLE>\n";
		echo "<INPUT TYPE='submit' VALUE='modify' />\n";
		echo "<INPUT TYPE='submit' NAME='DELETE' VALUE='delete record' />\n";
		echo "</FORM>\n";
	}
}


?>
