package D2P::Entity::Field;
use base qw(D2P::Entity);


sub	init
{
	my	$this = shift;

	$this->SUPER::init(@_);
	$this->{type} = 'field';
	$this->{fldName} = (@_ ? shift : "");
	$this->{fldType} = (@_ ? shift : "");
	$this->{leftHdl} = $this->{rightHdl} = -1;
	$this->{default} = "";
	$this->{notNull} = 0;
	$this->{table} = undef;
	$this->{reference} = undef;
	$this->{relation} = undef;
	$this->{comment} = undef;
}


sub	setReference
{
	my	$this	= shift;
	my	$ref	= shift;
	my	$rel	= shift;

	return 0 if defined $this->{reference};
	return 0 unless defined $rel;
	$this->{reference} = $ref;
	$this->{relation} = $rel;
	return 1;
}


1;
