package D2P::Entity::Field::Serial;
use base 'D2P::Entity::Field';

use	D2P::Entity::Sequence;


sub	default
{
	my	$this = shift;
	print STDERR "WARNING : SERIAL fields do not accept default values\n";
	return	undef;
}

sub	setReference
{
	my	$this = shift;
	print STDERR "WARNING : SERIAL fields may not be references\n";
	return	undef;
}


sub	preprocess
{
	my	$this	= shift;
	my	$mod	= $this->table()->module();
	$this->sequence(new D2P::Entity::Sequence());
	$this->sequence()->name($this->table()->name() . "_" . $this->fldName() . "_seq");
	$mod->addSequence($this->sequence());
}


1;

