package D2P::Entity::Relation::Inheritance;
use base qw(D2P::Entity::Relation);


sub	init
{
	my	$this = shift;

	$this->SUPER::init(@_);
	$this->{type} = 'Inheritance';
	$this->{isRelation} = 1;
	$this->{usePostgres} = 0;
}


sub	setTables
{
	my	($this, $source, $dest) = @_;

	$this->SUPER::setTables($source, $dest);
	$source->addAncestor($this);
}


1;
