package D2P::Entity::Relation;
use base qw(D2P::Entity);


sub	init
{
	my	$this = shift;

	$this->SUPER::init(@_);
	$this->{type} = '(unknown relation)';
	$this->{module} = undef;
	$this->{isRelation} = 1;
	$this->{fromId} = (@_ ? shift : undef);
	$this->{toId} = (@_ ? shift : undef);
	$this->{from} = undef;
	$this->{to} = undef;
}


sub	setTables
{
	my	($this, $source, $dest) = @_;
	$this->{from} = $source;
	$this->{to} = $dest;
	$source->addRelation($this);
}


1;

